import { BigNumberish, Signer } from "ethers";
import { ERC20FactoryV10 } from "../../types/ERC20FactoryV10";
import { CompaniesV10, DealRoomHubV10, ERC20FactoryV11, ERC721BeefLedgerV10, Grouping, MultisigWalletV10 } from "../../types";
import { ERC721BeefLedgerV11 } from "../../types/ERC721BeefLedgerV11";
import { GroupingFactoryV10 } from "../../types/GroupingFactoryV10";
/**ERC20Factory */
export declare function initializeERC20Factory(signer: Signer): Promise<[ERC20FactoryV10, string]>;
export declare function upgradeERC20Factory(signer: Signer, proxyAddress: string): Promise<ERC20FactoryV11>;
/**ERC721 */
export declare function initializeERC721(signer: Signer, multisigAddress: string): Promise<[ERC721BeefLedgerV10, string]>;
export declare function upgradeERC721(signer: Signer, proxyAddress: string): Promise<ERC721BeefLedgerV11>;
/** Multisig */
export declare function initializeMultisig(signer: Signer, owners: Array<string>, requirement: BigNumberish): Promise<[MultisigWalletV10, string]>;
/** Companies */
export declare function initializeCompanies(signer: Signer, owner: string): Promise<[CompaniesV10, string]>;
/** Grouping */
export declare function deployGrouping(signer: Signer, rgTokenAddress: string, erc721Address: string): Promise<Grouping>;
/** DealRoom */
export declare function initializeDealRoomHub(signer: Signer): Promise<[DealRoomHubV10, string]>;
/** Grouping */
export declare function initializeGroupingFactory(signer: Signer, owner: string): Promise<[GroupingFactoryV10, string]>;
