import { ethers, Signer, ContractTransaction } from "ethers";
import { GroupingFactoryV10 } from "./types";
import { DecodedCall } from "./abiDecoderController";
export declare class GroupingFactoryController {
    private _signer;
    private _groupingFactoryAddress;
    private _groupingFactoryContract?;
    constructor(groupingFactoryAddress: string, signerOrProvider: Signer | ethers.providers.ExternalProvider);
    static deployGroupingFactoryContract(signer: Signer, owner: string): Promise<[GroupingFactoryV10, string]>;
    private _getGroupingFactoryContract;
    /** Getters */
    getContract(): Promise<GroupingFactoryV10>;
    getGroupings(): Promise<Array<string>>;
    getGroupedTokens(): Promise<Array<string>>;
    getToken(groupingAddress: string): Promise<string>;
    getGrouping(rgToken: string): Promise<string>;
    /**Setters */
    deployGroupingContract(rgToken: string, erc721: string): Promise<ContractTransaction>;
    /** Helpers */
    static encodeCall(functionName: string, args?: any[]): string;
    static decodeCall(data: string): DecodedCall | null;
}
